<?php
namespace Bushelpowered\Api\Fulfillment\Contract\V1\Response;
        
class ContractListItemResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public string $remoteId;
    public ?string $displayId = null;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $destinationLocation;
    public ?int $deliveryPeriodStart = null;
    public ?int $deliveryPeriodEnd = null;
    public ?float $quantityContracted = null;
    public ?float $quantityRemaining = null;
    public ?string $quantityUom = null;
    public string $contractType;
    public ?float $pricing = null;
    public ?string $status = null;
    public ?int $remoteCreatedAt = null;
    public ?int $remoteUpdatedAt = null;
    public int $createdAt;
    public int $updatedAt;

    /**
     */
    public function __construct(string $id, string $remoteId, ?string $displayId, \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity, \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $destinationLocation, ?int $deliveryPeriodStart, ?int $deliveryPeriodEnd, ?float $quantityContracted, ?float $quantityRemaining, ?string $quantityUom, string $contractType, ?float $pricing, ?string $status, ?int $remoteCreatedAt, ?int $remoteUpdatedAt, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->remoteId = $remoteId;
        $this->displayId = $displayId;
        $this->account = $account;
        $this->company = $company;
        $this->commodity = $commodity;
        $this->destinationLocation = $destinationLocation;
        $this->deliveryPeriodStart = $deliveryPeriodStart;
        $this->deliveryPeriodEnd = $deliveryPeriodEnd;
        $this->quantityContracted = $quantityContracted;
        $this->quantityRemaining = $quantityRemaining;
        $this->quantityUom = $quantityUom;
        $this->contractType = $contractType;
        $this->pricing = $pricing;
        $this->status = $status;
        $this->remoteCreatedAt = $remoteCreatedAt;
        $this->remoteUpdatedAt = $remoteUpdatedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}