<?php
namespace Bushelpowered\Api\Fulfillment\Contract\V1\Response;
        
class PricingLineResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public int $id;
    public string $remoteId;
    public ?string $displayId = null;
    public ?int $sequenceNumber = null;
    public ?int $deliveryPeriodStart = null;
    public ?int $deliveryPeriodEnd = null;
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location;
    public ?float $quantityPriced = null;
    public ?string $quantityUom = null;
    public ?float $futuresPrice = null;
    public ?float $basis = null;
    public ?float $cashPrice = null;
    public ?string $futuresMonth = null;
    public ?string $pricingStatus = null;
    public ?string $signatureStatus = null;
    public ?int $remoteCreatedAt = null;
    public ?int $remoteUpdatedAt = null;
    public int $createdAt;
    public int $updatedAt;

    /**
     */
    public function __construct(int $id, string $remoteId, ?string $displayId, ?int $sequenceNumber, ?int $deliveryPeriodStart, ?int $deliveryPeriodEnd, \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $location, ?float $quantityPriced, ?string $quantityUom, ?float $futuresPrice, ?float $basis, ?float $cashPrice, ?string $futuresMonth, ?string $pricingStatus, ?string $signatureStatus, ?int $remoteCreatedAt, ?int $remoteUpdatedAt, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->remoteId = $remoteId;
        $this->displayId = $displayId;
        $this->sequenceNumber = $sequenceNumber;
        $this->deliveryPeriodStart = $deliveryPeriodStart;
        $this->deliveryPeriodEnd = $deliveryPeriodEnd;
        $this->location = $location;
        $this->quantityPriced = $quantityPriced;
        $this->quantityUom = $quantityUom;
        $this->futuresPrice = $futuresPrice;
        $this->basis = $basis;
        $this->cashPrice = $cashPrice;
        $this->futuresMonth = $futuresMonth;
        $this->pricingStatus = $pricingStatus;
        $this->signatureStatus = $signatureStatus;
        $this->remoteCreatedAt = $remoteCreatedAt;
        $this->remoteUpdatedAt = $remoteUpdatedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}