<?php

namespace Bushelpowered\Api\Grain\Contracts\Event;

class PricingHistoryRawVersions
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        'version1' => '\Bushelpowered\Api\Grain\Contracts\V1\Model\PricingHistoryRaw',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Version1(\Bushelpowered\Api\Grain\Contracts\V1\Model\PricingHistoryRaw $data): PricingHistoryRawVersions
    {
        return PricingHistoryRawVersions(version1, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    