<?php
namespace Bushelpowered\Api\Payments\Event;
        
class PaymentRawEvent implements Api\Common\Event\Event, Api\Common\Event\RawEvent
{
    public ?\Bushelpowered\Api\Payments\Event\PaymentRawVersions $raw = null;
    public string $idempotencyKey;
    public int $eventCreationTime;
    public ?string $tenantId = null;
    public ?string $deleteIntegrationId = null;

    /**
     */
    public function __construct(?\Bushelpowered\Api\Payments\Event\PaymentRawVersions $raw, string $idempotencyKey, int $eventCreationTime, ?string $tenantId, ?string $deleteIntegrationId)
    {
        $this->raw = $raw;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
        $this->deleteIntegrationId = $deleteIntegrationId;
    }
    
    public function getRaw(): ?\Bushelpowered\Api\Payments\Event\PaymentRawVersions
    {
        return $this->raw;
    }
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    public function getEventCreationTime(): int
    {
        return $this->eventCreationTime;
    }
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
    public function getDeleteIntegrationId(): ?string
    {
        return $this->deleteIntegrationId;
    }
}