<?php
namespace Bushelpowered\Api\Platform\Authorization\V1\Event;
        
class AccountIdentifiersRaw implements Api\Common\Event\RawRecord, Api\Common\HasSourceTimestamps
{
    public ?string $sourceName = null;
    /** @var \Bushelpowered\Api\Platform\Authorization\V1\Event\IdentifierRoles[] $identifierRoles */
    public array $identifierRoles;
    public int $sourceCreatedAt;
    public int $sourceUpdatedAt;
    public ?int $sourceDeletedAt = null;
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceAccountId = null;
    public ?string $sourceLocationId = null;

    /**
     * @param  \Bushelpowered\Api\Platform\Authorization\V1\Event\IdentifierRoles[]  $identifierRoles
     */
    public function __construct(?string $sourceName, array $identifierRoles, int $sourceCreatedAt, int $sourceUpdatedAt, ?int $sourceDeletedAt, string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceAccountId, ?string $sourceLocationId)
    {
        $this->sourceName = $sourceName;
        $this->identifierRoles = $identifierRoles;
        $this->sourceCreatedAt = $sourceCreatedAt;
        $this->sourceUpdatedAt = $sourceUpdatedAt;
        $this->sourceDeletedAt = $sourceDeletedAt;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceAccountId = $sourceAccountId;
        $this->sourceLocationId = $sourceLocationId;
    }
    
    public function getSourceCreatedAt(): int
    {
        return $this->sourceCreatedAt;
    }
    public function getSourceUpdatedAt(): int
    {
        return $this->sourceUpdatedAt;
    }
    public function getSourceDeletedAt(): ?int
    {
        return $this->sourceDeletedAt;
    }
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getSourceAccountId(): ?string
    {
        return $this->sourceAccountId;
    }
    public function getSourceLocationId(): ?string
    {
        return $this->sourceLocationId;
    }
}