<?php

namespace Bushelpowered\Api\Platform\Branding\V1\Request;

class BuildPlatform
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        'ios' => '\Bushelpowered\Api\Common\EmptyPHP',
        'android' => '\Bushelpowered\Api\Common\EmptyPHP',
        'both' => '\Bushelpowered\Api\Common\EmptyPHP',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Ios(\Bushelpowered\Api\Common\EmptyPHP $data): BuildPlatform
    {
        return BuildPlatform(ios, $data);
    }
    public static function Android(\Bushelpowered\Api\Common\EmptyPHP $data): BuildPlatform
    {
        return BuildPlatform(android, $data);
    }
    public static function Both(\Bushelpowered\Api\Common\EmptyPHP $data): BuildPlatform
    {
        return BuildPlatform(both, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    