<?php
namespace Bushelpowered\Api\Platform\Tenant\V1\Model;
        
class AccountStandard implements Api\Common\Event\StandardRecord, Api\Common\HasTimestamps
{
    public string $id;
    public string $tenantId;
    public string $datasourceId;
    public string $integrationId;
    public string $sourceId;
    public ?string $sourceLocationId = null;
    public ?string $locationId = null;
    public ?string $sourceName = null;
    public ?string $name = null;
    public ?string $accountId = null;
    public int $updatedAt;
    public int $createdAt;
    public ?int $deletedAt = null;

    /**
     */
    public function __construct(string $id, string $tenantId, string $datasourceId, string $integrationId, string $sourceId, ?string $sourceLocationId, ?string $locationId, ?string $sourceName, ?string $name, ?string $accountId, int $updatedAt, int $createdAt, ?int $deletedAt)
    {
        $this->id = $id;
        $this->tenantId = $tenantId;
        $this->datasourceId = $datasourceId;
        $this->integrationId = $integrationId;
        $this->sourceId = $sourceId;
        $this->sourceLocationId = $sourceLocationId;
        $this->locationId = $locationId;
        $this->sourceName = $sourceName;
        $this->name = $name;
        $this->accountId = $accountId;
        $this->updatedAt = $updatedAt;
        $this->createdAt = $createdAt;
        $this->deletedAt = $deletedAt;
    }
    
    public function getId(): string
    {
        return $this->id;
    }
    public function getTenantId(): string
    {
        return $this->tenantId;
    }
    public function getDatasourceId(): string
    {
        return $this->datasourceId;
    }
    public function getIntegrationId(): string
    {
        return $this->integrationId;
    }
    public function getSourceId(): string
    {
        return $this->sourceId;
    }
    public function getLocationId(): ?string
    {
        return $this->locationId;
    }
    public function getAccountId(): ?string
    {
        return $this->accountId;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
}