<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Response;
        
class CompanyResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp, Api\Common\HasDeletedAtTimestamp
{
    public string $id;
    public string $slug;
    public int $cqgCategoryId;
    public ?int $ingestEnabledAt = null;
    public bool $displayConvertedBasis;
    public string $bidRoundingStrategy;
    public int $cashBidDecimalFormat;
    public int $createdAt;
    public int $updatedAt;
    public ?int $deletedAt = null;

    /**
     */
    public function __construct(string $id, string $slug, int $cqgCategoryId, ?int $ingestEnabledAt, bool $displayConvertedBasis, string $bidRoundingStrategy, int $cashBidDecimalFormat, int $createdAt, int $updatedAt, ?int $deletedAt)
    {
        $this->id = $id;
        $this->slug = $slug;
        $this->cqgCategoryId = $cqgCategoryId;
        $this->ingestEnabledAt = $ingestEnabledAt;
        $this->displayConvertedBasis = $displayConvertedBasis;
        $this->bidRoundingStrategy = $bidRoundingStrategy;
        $this->cashBidDecimalFormat = $cashBidDecimalFormat;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
}