<?php
namespace Bushelpowered\Api\Trade\Offers\V1\Model;
        
class OrderStandard implements Api\Common\Event\Event
{
    public \Bushelpowered\Api\Trade\Offers\V1\OrderStatus $status;
    public string $companySlug;
    public string $contractId;
    public int $quantity;
    public float $price;
    public float $basisPrice;
    public float $futuresPrice;
    public ?string $comments = null;
    public string $bushelAccount;
    public string $erpAccount;
    public string $erpLocation;
    public string $erpCommodity;
    public int $orderCreatedAt;
    public int $expiresAt;
    public bool $forceFill;
    public bool $careOrder;
    public string $contractSymbol;
    public int $pricingType;
    public string $unitOfMeasure;
    public string $commodityCode;
    public string $commodityName;
    public string $locationName;
    public string $exchangeAbbreviation;
    public string $futuresSymbol;
    public int $deliveryStart;
    public int $deliveryEnd;
    public string $chainOrderId;
    public string $idempotencyKey;
    public int $eventCreationTime;
    public ?string $tenantId = null;

    /**
     */
    public function __construct(\Bushelpowered\Api\Trade\Offers\V1\OrderStatus $status, string $companySlug, string $contractId, int $quantity, float $price, float $basisPrice, float $futuresPrice, ?string $comments, string $bushelAccount, string $erpAccount, string $erpLocation, string $erpCommodity, int $orderCreatedAt, int $expiresAt, bool $forceFill, bool $careOrder, string $contractSymbol, int $pricingType, string $unitOfMeasure, string $commodityCode, string $commodityName, string $locationName, string $exchangeAbbreviation, string $futuresSymbol, int $deliveryStart, int $deliveryEnd, string $chainOrderId, string $idempotencyKey, int $eventCreationTime, ?string $tenantId)
    {
        $this->status = $status;
        $this->companySlug = $companySlug;
        $this->contractId = $contractId;
        $this->quantity = $quantity;
        $this->price = $price;
        $this->basisPrice = $basisPrice;
        $this->futuresPrice = $futuresPrice;
        $this->comments = $comments;
        $this->bushelAccount = $bushelAccount;
        $this->erpAccount = $erpAccount;
        $this->erpLocation = $erpLocation;
        $this->erpCommodity = $erpCommodity;
        $this->orderCreatedAt = $orderCreatedAt;
        $this->expiresAt = $expiresAt;
        $this->forceFill = $forceFill;
        $this->careOrder = $careOrder;
        $this->contractSymbol = $contractSymbol;
        $this->pricingType = $pricingType;
        $this->unitOfMeasure = $unitOfMeasure;
        $this->commodityCode = $commodityCode;
        $this->commodityName = $commodityName;
        $this->locationName = $locationName;
        $this->exchangeAbbreviation = $exchangeAbbreviation;
        $this->futuresSymbol = $futuresSymbol;
        $this->deliveryStart = $deliveryStart;
        $this->deliveryEnd = $deliveryEnd;
        $this->chainOrderId = $chainOrderId;
        $this->idempotencyKey = $idempotencyKey;
        $this->eventCreationTime = $eventCreationTime;
        $this->tenantId = $tenantId;
    }
    
    public function getIdempotencyKey(): string
    {
        return $this->idempotencyKey;
    }
    public function getEventCreationTime(): int
    {
        return $this->eventCreationTime;
    }
    public function getTenantId(): ?string
    {
        return $this->tenantId;
    }
}